# Generated by Django 4.0.3 on 2022-06-20 09:56

import django.core.validators
from django.db import migrations, models
import django.db.migrations.operations.special
import django.db.models.deletion


def create_relations(apps, schema_editor):
    Repository = apps.get_model('core', 'Repository')
    RepositoryProgrammingLanguage = apps.get_model('core', 'RepositoryProgrammingLanguage')

    for repository in Repository.objects.all():
        for programming_language in repository.programming_languages.all():
            RepositoryProgrammingLanguage(
                repository=repository,
                programming_language=programming_language,
                usage=0.1,
            ).save()


class Migration(migrations.Migration):

    dependencies = [
        ('core', '0025_rename_code_repository'),
    ]

    operations = [
        migrations.CreateModel(
            name='RepositoryProgrammingLanguage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('repository', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.repository')),
                ('programming_language', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.programminglanguage')),
                ('usage', models.DecimalField(decimal_places=1, max_digits=4, validators=[django.core.validators.MinValueValidator(0.1), django.core.validators.MaxValueValidator(100.0)])),
            ],
            options={
                'unique_together': {('repository', 'programming_language')},
            },
        ),
        migrations.RunPython(
            code=create_relations,
            reverse_code=django.db.migrations.operations.special.RunPython.noop,
        ),
        migrations.RemoveField(
            model_name='repository',
            name='programming_languages',
        ),
        migrations.AddField(
            model_name='repository',
            name='programming_languages',
            field=models.ManyToManyField(related_name='repositories', through='core.RepositoryProgrammingLanguage', to='core.programminglanguage'),
        ),
    ]
